package de.phoenixstudios.roomcontrol;

import android.app.Activity;
import android.app.AlertDialog;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;
import android.widget.Toast;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.InetAddress;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.Timer;
import java.util.TimerTask;


public class MainActivity extends Activity {
    static boolean TCPCommandThreadAlive=true;
    static int TCPCommandStatus=0;
    static String TCPCommandReceivedString="";
    static String TCPCommandString;
    static int[] Channelvalue = new int[8];
    static boolean DontSendData=false;
    final Handler myHandler = new Handler();
    static String ServerAnswer = "";

    private SeekBar bar1;
    private SeekBar bar2;
    private SeekBar bar3;
    private SeekBar bar4;
    private SeekBar bar5;
//    private SeekBar bar6;
    private SeekBar bar7;
    private SeekBar bar8;


    public void ShowMessage(String msg) {
        AlertDialog.Builder dlgAlert = new AlertDialog.Builder(MainActivity.this);
        dlgAlert.setMessage(msg);
        dlgAlert.setTitle("Roomcontrol");
        dlgAlert.setPositiveButton("OK", null);
        dlgAlert.setCancelable(true);
        dlgAlert.create().show();
    }

    public static byte cbytetojavabyte(int value){
        return (byte)(value & 0xFF);
    }

    private class TCPCommandThread extends AsyncTask<String, Integer, Long> {
        @Override
        protected Long doInBackground(String... args) {
            long result = 0;

            Socket TCPSocket=null;
            InetAddress serverAddr=null;
            BufferedWriter outToServer=null;
            BufferedReader inFromServer=null;
            char[] Buffer;
            int ReceiveLength;

            if (BuildConfig.DEBUG) {
                System.out.println("TCPCommandThread started.");
            }

            while(TCPCommandThreadAlive) {
                try {
                    if (TCPSocket == null) {
                        // Verbindung herstellen, falls nicht (mehr) verbunden
                        try {
                            serverAddr = InetAddress.getByName("192.168.0.13");
                        } catch (UnknownHostException error) {
                            if (BuildConfig.DEBUG) {
                                System.out.println(error.toString());
                            }
                        }
                        TCPSocket = new Socket(serverAddr, 10014);
                        TCPSocket.setSoTimeout(10000);

                        outToServer = new BufferedWriter(new OutputStreamWriter(TCPSocket.getOutputStream()));
                        inFromServer = new BufferedReader(new InputStreamReader(TCPSocket.getInputStream()));
                    }

                    // Wenn neues Kommando vorhanden, dann dieses senden
                    if (TCPCommandStatus == 1) {
/*
                        if (BuildConfig.DEBUG) {
                            System.out.println("Writing data: "+TCPCommandString);
                        }
*/
                        outToServer.write(TCPCommandString.length());
                        outToServer.flush();
                        Buffer = TCPCommandString.toCharArray();
                        outToServer.write(Buffer, 0, TCPCommandString.length());
                        outToServer.flush();
/*
                        if (BuildConfig.DEBUG) {
                            System.out.println("Data written.");
                        }
*/
                        TCPCommandStatus=2;

                        ReceiveLength = inFromServer.read();
                        if (ReceiveLength>0) {
                            Buffer = new char[ReceiveLength];
                            inFromServer.read(Buffer, 0, ReceiveLength);
                            TCPCommandReceivedString = String.valueOf(Buffer, 0, ReceiveLength);
/*
                            if (BuildConfig.DEBUG) {
                                System.out.println("Received data: " + TCPCommandReceivedString);
                            }
*/
                            TCPCommandStatus = 3;
                        }
                    }else if (TCPCommandStatus==4){
                        // falls kein Kommando gesendet werden soll Kanalwerte abfragen
                        TCPSocket.setSoTimeout(5000);

                        ServerAnswer="C?";
                        outToServer.write(ServerAnswer.length());
                        outToServer.flush();
                        Buffer = ServerAnswer.toCharArray();
                        outToServer.write(Buffer, 0, ServerAnswer.length());
                        outToServer.flush();

                        TCPCommandStatus = 5;
                        ReceiveLength = inFromServer.read();
                        if (ReceiveLength > 0) {
                            Buffer = new char[ReceiveLength];
                            inFromServer.read(Buffer, 0, ReceiveLength);
                            ServerAnswer = String.valueOf(Buffer, 0, ReceiveLength);
                        }

                        TCPCommandStatus = 6;
                    }
                } catch (IOException error) {
                    if (BuildConfig.DEBUG) {
                        System.out.println(error.toString());
                    }

                    TCPCommandStatus = -1;

                    // Verbindung beenden und neu etablieren
                    try {
                        if (TCPSocket!=null){
                            if (TCPSocket.isConnected()) {
                                inFromServer.close();
                                outToServer.close();
                                TCPSocket.close();
                            }
                        }
                        TCPSocket = null;
                    }catch(Exception error2){
                        if (BuildConfig.DEBUG) {
                            System.out.println(error2.toString());
                        }
                    }
                }
            }

            if (TCPSocket != null) {
                try {
                    inFromServer.close();
                    outToServer.close();
                    TCPSocket.close();
                } catch (IOException error) {
                    if (BuildConfig.DEBUG) {
                        System.out.println(error.toString());
                    }
                }
            }

            return result;
        }

        @Override
        protected void onProgressUpdate(Integer... progress) {
            setProgress(progress[0]);
        }

        @Override
        protected void onPostExecute(Long result) {
            if (BuildConfig.DEBUG) {
                System.out.println("TCPCommandThread closed.");
            }
        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        // Seekbars zuweisen
        bar1 = (SeekBar)findViewById(R.id.seekBar1); // make seekbar object
        bar1.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
            int progress = 0;
            @Override
            public void onProgressChanged(SeekBar seekBar, int progresValue, boolean fromUser) {
                progress = progresValue;
                if (!DontSendData) {
                    SetChannel(1, -1, progress, 0);
                }
                //Toast.makeText(getApplicationContext(), "Changing seekbar's 1 progress", Toast.LENGTH_SHORT).show();
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {
                //Toast.makeText(getApplicationContext(), "Started tracking seekbar 1", Toast.LENGTH_SHORT).show();
            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
                //Toast.makeText(getApplicationContext(), "Stopped tracking seekbar 1", Toast.LENGTH_SHORT).show();
            }
        });
        bar2 = (SeekBar)findViewById(R.id.seekBar2); // make seekbar object
        bar2.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
            int progress = 0;
            @Override
            public void onProgressChanged(SeekBar seekBar, int progresValue, boolean fromUser) {
                progress = progresValue;
                if (!DontSendData) {
                    SetChannel(2, -1, progress, 0);
                }
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {
            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
            }
        });
        bar3 = (SeekBar)findViewById(R.id.seekBar3); // make seekbar object
        bar3.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
            int progress = 0;
            @Override
            public void onProgressChanged(SeekBar seekBar, int progresValue, boolean fromUser) {
                progress = progresValue;
                if (!DontSendData) {
                    SetChannel(3, -1, progress, 0);
                }
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {
            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
            }
        });
        bar4 = (SeekBar)findViewById(R.id.seekBar4); // make seekbar object
        bar4.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
            int progress = 0;
            @Override
            public void onProgressChanged(SeekBar seekBar, int progresValue, boolean fromUser) {
                progress = progresValue;
                if (!DontSendData) {
                    SetChannel(4, -1, progress, 0);
                }
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {
            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
            }
        });
        bar5 = (SeekBar)findViewById(R.id.seekBar5); // make seekbar object
        bar5.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
            int progress = 0;
            @Override
            public void onProgressChanged(SeekBar seekBar, int progresValue, boolean fromUser) {
                progress = progresValue;
                if (!DontSendData) {
                    SetChannel(5, -1, progress, 0);
                }
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {
            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
            }
        });
/*
        bar6 = (SeekBar)findViewById(R.id.seekBar6); // make seekbar object
        bar6.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
            int progress = 0;
            @Override
            public void onProgressChanged(SeekBar seekBar, int progresValue, boolean fromUser) {
                progress = progresValue;
                if (!DontSendData) {
                    SetChannel(6, -1, progress, 0);
                }
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {
            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
            }
        });
*/
        bar7 = (SeekBar)findViewById(R.id.seekBar7); // make seekbar object
        bar7.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
            int progress = 0;
            @Override
            public void onProgressChanged(SeekBar seekBar, int progresValue, boolean fromUser) {
                progress = progresValue;
                if (!DontSendData) {
                    SetChannel(7, -1, progress, 0);
                }
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {
            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
            }
        });
        bar8 = (SeekBar)findViewById(R.id.seekBar8); // make seekbar object
        bar8.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
            int progress = 0;
            @Override
            public void onProgressChanged(SeekBar seekBar, int progresValue, boolean fromUser) {
                progress = progresValue;
                if (!DontSendData) {
                    SetChannel(8, -1, progress, 0);
                }
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {
            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
            }
        });

        Timer myTimer = new Timer();
        myTimer.schedule(new TimerTask() {
            @Override
            public void run() {
                UpdateGUI();
            }
        }, 0, 500);


        // Netzwerkthread erstellen
        TCPCommandThreadAlive=true;
        new TCPCommandThread().execute();
    }

    private void UpdateGUI() {
        myHandler.post(myRunnable);
    }

    final Runnable myRunnable = new Runnable() {
        public void run() {
            // Answer="C1=222;C2=232;C3=0;C4=0;C5=0;C6=0;C7=0;C8=0;"

            TCPCommandStatus=4;

            String sChannel, sValue;
            String Answer_temp=ServerAnswer;
            if ((ServerAnswer.length()>24) && (ServerAnswer.contains("="))) {
                try {
                    do {
                        sChannel = String.copyValueOf(Answer_temp.toCharArray(), Answer_temp.indexOf("C") + 1, Answer_temp.indexOf("=") - Answer_temp.indexOf("C") - 1);
                        sValue = String.copyValueOf(Answer_temp.toCharArray(), Answer_temp.indexOf("=") + 1, Answer_temp.indexOf(";") - Answer_temp.indexOf("=") - 1);

                        Answer_temp = String.copyValueOf(Answer_temp.toCharArray(), Answer_temp.indexOf(";") + 1, Answer_temp.length() - (Answer_temp.indexOf(";") + 1));

                        // Neuen Wert setzen
                        Channelvalue[Integer.parseInt(sChannel)-1] = Integer.parseInt(sValue);
                    } while (Answer_temp.contains("="));

                    // Sliders setzen
                    DontSendData = true;
                    bar1.setProgress(Channelvalue[0]);
                    bar2.setProgress(Channelvalue[1]);
                    bar3.setProgress(Channelvalue[2]);
                    bar4.setProgress(Channelvalue[3]);
                    bar5.setProgress(Channelvalue[4]);
                    //bar6.setProgress(Channelvalue[5]);
                    bar7.setProgress(Channelvalue[6]);
                    bar8.setProgress(Channelvalue[7]);
                    DontSendData = false;

                    // Hauptbildschirm aktualisieren
                    View v = findViewById (R.id.roomcontrol);
                    v.invalidate();
                }catch(Exception e){}
            }
        }
    };

    @Override
    protected void onStart(){
        super.onStart();

        // Netzwerkthread wiederherstellen
        if (!TCPCommandThreadAlive) {
            TCPCommandThreadAlive = true;
            new TCPCommandThread().execute();
        }
    }

    @Override
    protected void onStop(){
        super.onStop();
        TCPCommandThreadAlive=false;
    }

    //Fires after the OnStop() state
    @Override
    protected void onDestroy() {
        super.onDestroy();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_about) {
            ShowMessage("Version 1.0.0 vom 26.03.2018");
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    public static String SendReceiveTCPCommand(String cmd){
        String Answer = "";

        TCPCommandString = cmd;
        TCPCommandStatus = 1;

        int WaitForTCPCommand;

        WaitForTCPCommand = 50; // 5 Sekunden bei internem WLAN
        while (WaitForTCPCommand > 0) {
            WaitForTCPCommand--;

            if ((TCPCommandStatus == 3) || (TCPCommandStatus == -1)) {
                // Entweder Fehler oder Fertig -> Schleife beenden
                WaitForTCPCommand = 0;
            }

            try {
                Thread.sleep(100);
            } catch (InterruptedException error) {

            }
        }

        switch (TCPCommandStatus) {
            case -1:
                Answer = "Fehler bei Datenübertragung!";
                break;
            case 1:
                Answer = "Fehler: Kommando nicht gesendet!";
                break;
            case 2:
                Answer = "Fehler: Keine Antwort von PC_DIMMER_Server!";
                break;
            case 3:
                Answer = TCPCommandReceivedString;
                break;
            default:
                Answer = "Unbekannter Fehler!";
                break;
        }

        TCPCommandStatus = 0;

        return Answer;
    }

    public static void SendTCPCommand(String cmd){
        TCPCommandString = cmd;
        TCPCommandStatus = 1;
    }

    public void SetChannel(int Channel, int Startvalue, int Endvalue, int Fadetime){
        SendTCPCommand("C" + String.valueOf(Channel) + ":" + String.valueOf(Startvalue) + ">" + String.valueOf(Endvalue) + "in" + String.valueOf(Fadetime) + "ms;");

        // Neuen Endwert setzen
        //Channelvalue[Channel-1]=Endvalue;
    }

    public void scene1btnClick(View v){
        // Arbeitslicht
        try {
            SetChannel(1, -1, 255, 3000); // Linestras Esstisch
            Thread.sleep(100);
            SetChannel(2, -1, 255, 3000); // Linestras Sofa
            Thread.sleep(100);
            SetChannel(3, -1, 0, 3000); // Lichterketten
            Thread.sleep(100);
            SetChannel(4, -1, 255, 3000); // Regalbeleuchtung
            Thread.sleep(100);
            SetChannel(5, -1, 255, 3000); // Esstisch
            Thread.sleep(100);
            SetChannel(7, -1, 255, 3000); // Sofa
            //SetChannel(8, -1, 0, 3000); // Treppenlicht
        }catch(InterruptedException e){}
    }

    public void scene2btnClick(View v){
        // Fernsehbeleuchtung
        try {
            SetChannel(1, -1, 0, 3000); // Linestras Esstisch
            Thread.sleep(100);
            SetChannel(2, -1, 0, 3000); // Linestras Sofa
            Thread.sleep(100);
            SetChannel(3, -1, 128, 3000); // Lichterketten
            Thread.sleep(100);
            SetChannel(4, -1, 50, 3000); // Regalbeleuchtung
            Thread.sleep(100);
            SetChannel(5, -1, 0, 3000); // Esstisch
            Thread.sleep(100);
            SetChannel(7, -1, 50, 3000); // Sofa
        }catch(InterruptedException e){}
    }

    public void scene3btnClick(View v){
        // nur Esstisch
        try {
            SetChannel(1, -1, 0, 3000); // Linestras Esstisch
            Thread.sleep(100);
            SetChannel(2, -1, 0, 3000); // Linestras Sofa
            Thread.sleep(100);
            SetChannel(3, -1, 0, 3000); // Lichterketten
            Thread.sleep(100);
            SetChannel(4, -1, 0, 3000); // Regalbeleuchtung
            Thread.sleep(100);
            SetChannel(5, -1, 128, 3000); // Esstisch
            Thread.sleep(100);
            SetChannel(7, -1, 0, 3000); // Sofa
        }catch(InterruptedException e){}
    }

    public void scene4btnClick(View v){
        // nur Wohnzimmertisch
        try {
            SetChannel(1, -1, 0, 3000); // Linestras Esstisch
            Thread.sleep(100);
            SetChannel(2, -1, 0, 3000); // Linestras Sofa
            Thread.sleep(100);
            SetChannel(3, -1, 0, 3000); // Lichterketten
            Thread.sleep(100);
            SetChannel(4, -1, 0, 3000); // Regalbeleuchtung
            Thread.sleep(100);
            SetChannel(5, -1, 0, 3000); // Esstisch
            Thread.sleep(100);
            SetChannel(7, -1, 128, 3000); // Sofa
        }catch(InterruptedException e){}
    }

    public void scene5btnClick(View v){
        // Alles aus
        try {
            SetChannel(1, -1, 0, 3000); // Linestras Esstisch
            Thread.sleep(100);
            SetChannel(2, -1, 0, 3000); // Linestras Sofa
            Thread.sleep(100);
            SetChannel(3, -1, 0, 3000); // Lichterketten
            Thread.sleep(100);
            SetChannel(4, -1, 0, 3000); // Regalbeleuchtung
            Thread.sleep(100);
            SetChannel(5, -1, 0, 3000); // Esstisch
            Thread.sleep(100);
            SetChannel(7, -1, 0, 3000); // Sofa
        }catch(InterruptedException e){}
    }
}
